#----------------------------
# K8S DSL 
#----------------------------

.functions-helpers: &functions-helpers |

  # === Generate Manifest(s) ===
  function generate_manifest() {
    envsubst < ci/kube/k8s-templates/simple.web.app.template.yaml > ./kube/simple.web.app.${CI_COMMIT_SHORT_SHA}.yaml
  }

  # === Apply ===
  function apply() {
    kubectl apply -f ./kube/simple.web.app.${CI_COMMIT_SHORT_SHA}.yaml -n ${KUBE_NAMESPACE} --record=true
  }

  # === Remove Deployment ===
  function delete_deployment() {
    kubectl delete -f ./kube/simple.web.app.${CI_COMMIT_SHORT_SHA}.yaml -n ${KUBE_NAMESPACE}
  }

  # === Scale / Downscale ===
  function scale() {
    kubectl scale --replicas=$1 deploy ${CI_PROJECT_NAME} -n ${KUBE_NAMESPACE}
  }

.k8s:dsl:
  image: maykonlf/pipeline-kubectl:latest
  before_script:
    - *functions-helpers

